"""Sharelinks Mutation."""

# pylint: disable=no-member, unused-argument, too-many-locals, duplicate-code, wildcard-import, unused-wildcard-import, cyclic-import


# Autogenerated
# DO NOT MODIFY

from __future__ import annotations

import logging
from typing import TYPE_CHECKING, Any, Dict, List, Optional, Tuple, Union

from taegis_sdk_python import GraphQLNoRowsInResultSetError
from taegis_sdk_python._consts import TaegisEnum
from taegis_sdk_python.services.sharelinks.types import *
from taegis_sdk_python.utils import (
    build_output_string,
    parse_union_result,
    prepare_input,
)

if TYPE_CHECKING:  # pragma: no cover
    from taegis_sdk_python.services.sharelinks import SharelinksService

log = logging.getLogger(__name__)


class TaegisSDKSharelinksMutation:
    """Taegis Sharelinks Mutation operations."""

    def __init__(self, service: SharelinksService):
        self.service = service

    def create_share_link(self, input_: ShareLinkCreateInput) -> ShareLink:
        """Create a new ShareLink."""
        endpoint = "createShareLink"

        result = self.service.execute_mutation(
            endpoint=endpoint,
            variables={
                "input": prepare_input(input_),
            },
            output=build_output_string(ShareLink),
        )
        if result.get(endpoint) is not None:
            return ShareLink.from_dict(result.get(endpoint))
        raise GraphQLNoRowsInResultSetError("for mutation createShareLink")

    def create_share_links(self, input_: List[ShareLinkCreateInput]) -> List[ShareLink]:
        """Create multiple ShareLinks."""
        endpoint = "createShareLinks"

        result = self.service.execute_mutation(
            endpoint=endpoint,
            variables={
                "input": prepare_input(input_),
            },
            output=build_output_string(ShareLink),
        )
        if result.get(endpoint) is not None:
            return ShareLink.schema().load(
                [r or {} for r in result.get(endpoint)], many=True
            )
        raise GraphQLNoRowsInResultSetError("for mutation createShareLinks")
